#!/bin/sh

KEY_ALGORITHM=RSA
KEY_SIZE=1024
VALIDITY=365

CLIENT_USERNAME=client
CLIENT_STORE=conf/client.jks
CLIENT_STORE_PREKEY=conf/client-prekey.jks
CLIENT_STORE_PWD=client_store_pwd
CLIENT_PUBLIC_KEY=client.cer
CLIENT_KEY_PWD=client_key_pwd

SERVICE_USERNAME=service
SERVICE_STORE=resources/service.jks
SERVICE_STORE_PREKEY=resources-prekey/service.jks
SERVICE_STORE_PWD=service_store_pwd
SERVICE_PUBLIC_KEY=service.cer
SERVICE_KEY_PWD=service_key_pwd

echo "Please enter the information about the web service"
keytool -genkey -alias $SERVICE_USERNAME -keyalg $KEY_ALGORITHM -keysize $KEY_SIZE -validity $VALIDITY -keypass $SERVICE_KEY_PWD -keystore $SERVICE_STORE -storepass $SERVICE_STORE_PWD

echo "Please enter the information about the service client"
keytool -genkey -alias $CLIENT_USERNAME -keyalg $KEY_ALGORITHM -keysize $KEY_SIZE -validity $VALIDITY -keypass $CLIENT_KEY_PWD -keystore $CLIENT_STORE -storepass $CLIENT_STORE_PWD

# the keystores for the predetermined key encryption don't need the public key of the other side
cp $SERVICE_STORE $SERVICE_STORE_PREKEY

cp $CLIENT_STORE $CLIENT_STORE_PREKEY

keytool -alias $SERVICE_USERNAME -export -keystore $SERVICE_STORE -storepass $SERVICE_STORE_PWD -file $SERVICE_PUBLIC_KEY

keytool -import -alias $SERVICE_USERNAME -file $SERVICE_PUBLIC_KEY -keystore $CLIENT_STORE -storepass $CLIENT_STORE_PWD

keytool -alias $CLIENT_USERNAME -export -keystore $CLIENT_STORE -storepass $CLIENT_STORE_PWD -file $CLIENT_PUBLIC_KEY

keytool -import -alias $CLIENT_USERNAME -file $CLIENT_PUBLIC_KEY -keystore $SERVICE_STORE -storepass $SERVICE_STORE_PWD

rm $CLIENT_PUBLIC_KEY $SERVICE_PUBLIC_KEY

