
package fibonacci;

import org.apache.axiom.om.*;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.client.Options;
import org.apache.axis2.client.ServiceClient;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.context.ConfigurationContextFactory;

public class Axis2Client {

	public static void main (String[] args) throws Exception {
		if (args.length != 4) {
			System.out.println("Usage: java fibonacci.Axis2Client <port> <n> <repo_path> <config_file>");
		}

		java.security.Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());

		int port = Integer.parseInt(args[0]);

		String n = args[1];

		ConfigurationContext ctx = ConfigurationContextFactory.createConfigurationContextFromFileSystem(args[2], args[3]);

		ServiceClient client = new ServiceClient(ctx, null);
//		client.setTargetEPR(new EndpointReference("http://localhost:"+port+"/axis2/services/FibonacciService"));

		Options options = new Options();
		options.setAction("urn:calculateFibonacci");
		options.setTo(new EndpointReference("http://localhost:"+port+"/axis2/services/FibonacciService"));
		client.setOptions(options);

		OMFactory factory = OMAbstractFactory.getOMFactory();
		OMNamespace ns = factory.createOMNamespace("http://fibonacci/xsd", "ns1");
		OMElement request = factory.createOMElement("calculateFibonacci", ns);
		OMElement childElem = factory.createOMElement("in0", null);
		childElem.setText(n);
		request.addChild(childElem);
//		System.out.println(request);

		OMElement response = client.sendReceive(request);
//		System.out.println(response);
		System.out.println("Fibonacci("+n+") = "+response.getFirstElement().getText());
	}
}

