
package fibonacci;

import org.apache.ws.security.WSPasswordCallback;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;

import java.io.IOException;

public class PWHandlerClient implements CallbackHandler {

	// a known key for the predetermined key encryption
	private static final byte[] key = {
		(byte) 0x31, (byte) 0xfd, (byte) 0xcb, (byte) 0xda,
		(byte) 0xfb, (byte) 0xcd, (byte) 0x6b, (byte) 0xa8,
		(byte) 0xe6, (byte) 0x19, (byte) 0xa7, (byte) 0xbf,
		(byte) 0x51, (byte) 0xf7, (byte) 0xc7, (byte) 0x3e };

    public void handle (Callback[] callbacks) throws IOException, UnsupportedCallbackException {

        for (int i = 0; i < callbacks.length; i++) {
            WSPasswordCallback pc = (WSPasswordCallback) callbacks[i];
            String id = pc.getIdentifer();
//			System.out.println("identifier: "+id+", usage: "+pc.getUsage());

			if (pc.getUsage() == WSPasswordCallback.KEY_NAME) {
				pc.setKey(key);

			} else if ("wsuser".equals(id)) {
				// for authentication
                pc.setPassword("wspwd");

            } else if ("client".equals(id)) {
				// key password
				pc.setPassword("client_key_pwd");

			} else {
				throw new IOException("unknown user: "+pc.getIdentifer());
			}
        }
    }
}
