package fibonacci;

import java.util.Iterator;

import javax.xml.soap.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Node;

public class SAAJClient {

   public static void main (String args[]) {
		String n1 = args[0];

		String serviceName = args[1];

		int port = 8080;
		if (args.length > 2)
			port = Integer.parseInt(args[2]);

		java.security.Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());

		try {
			// First create the connection
			SOAPConnectionFactory soapConnFactory = SOAPConnectionFactory.newInstance();
			SOAPConnection connection = soapConnFactory.createConnection();

			// Next, create the actual message
			MessageFactory messageFactory = MessageFactory.newInstance();
			SOAPMessage message = messageFactory.createMessage();

// set HTTP SOAPAction header
			MimeHeaders hd = message.getMimeHeaders();
			hd.setHeader("SOAPAction", "urn:calculateFibonacci");
// TODO: Axis has a bug (Axis2-1014) that prevents MimeHeaders from being set for SAAJ clients

			SOAPPart soapPart = message.getSOAPPart();
			SOAPEnvelope envelope = soapPart.getEnvelope();

// start: setting SOAP headers - optional
			// Create and populate the header
			SOAPHeader header = message.getSOAPHeader();
			if (header == null)
				header = envelope.addHeader();

			// Will use the default actor "next" for this example, otherwise
			// use he.setActor(String actorURI) to define actor.
/*
			SOAPHeaderElement he = header.addHeaderElement(
					envelope.createName("foo", "ns1", "http://example.com/SOAPHeader"));
			he.setMustUnderstand(false);
			he.setValue("bar");
*/
// end: setting SOAP headers

// start: setting SOAP body
			// Create and populate the body
			SOAPBody body = envelope.getBody();

			// Create the main element and namespace
			SOAPElement bodyElement = body.addChildElement(
				envelope.createName("calculateFibonacci", "ns1", "http://fibonacci/xsd"));
			// Add content
			bodyElement.addChildElement("in0").addTextNode(n1);

			// Save the message
			message.saveChanges();
// end: setting SOAP body

			// Check the input
			/*
			System.out.println("\nRequest:\n");
			message.writeTo(System.out);
			System.out.println();
			*/

			// Set the destination
			String destination = "http://localhost:"+port+"/axis2/services/"+serviceName;
			// Send the message and get the reply
			SOAPMessage reply = connection.call(message, destination);

			// Retrieve the result
			soapPart = reply.getSOAPPart();
			envelope = soapPart.getEnvelope();
			body = envelope.getBody();

			Iterator iter = body.getChildElements();
			Node fibReturn = ((Node) iter.next()).getFirstChild();
			Node result = fibReturn.getFirstChild();

			System.out.println("Fibonacci("+n1+") = "+result);

			// Check the output
			/*
			System.out.println("\nResponse:\n");
			// Create the transformer
			TransformerFactory transformerFactory = TransformerFactory.newInstance();
			Transformer transformer = transformerFactory.newTransformer();
			// Extract the content of the reply
			Source sourceContent = reply.getSOAPPart().getContent();
			// Set the output for the transformation
			StreamResult result = new StreamResult(System.out);
			transformer.transform(sourceContent, result);
			System.out.println();
			*/

			// Close the connection           
			connection.close();
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
}

